/*
    Video maid
    copyright (c) 1998-2002 Iwamoto,Kazuki http://www.maid.org/ iwm@maid.org

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <string.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <unistd.h>
#include "avicore.h"
#include "file.h"
#include "other.h"
#include "signal.h"
#include "size.h"
#include "thread.h"


/******************************************************************************
*                                                                             *
* եؿ                                                              *
*                                                                             *
******************************************************************************/
/*	ե˲ä
	file,ե̾															*/
void set_history(gchar *file)
{
	gchar *label;
	gint i,count;
	GList *glist;
	GtkWidget *sub_menu,*menu_item;

	sub_menu=gtk_item_factory_get_widget(item_factory_menu,
														"<main>/ե(F)");
	glist=gtk_container_children(GTK_CONTAINER(sub_menu));
	count=g_list_length(glist);
	for (i=0;i<count-MENUFILE-1;i++) {
		menu_item=g_list_nth_data(glist,i+MENUFILE-1);
		label=gtk_object_get_user_data(GTK_OBJECT(menu_item));
		if (strcmp(label,file)==0) {
			gtk_container_remove(GTK_CONTAINER(sub_menu),menu_item);
			break;
		}
	}
	g_list_free(glist);
	if (i>=history) {
		glist=gtk_container_children(GTK_CONTAINER(sub_menu));
		gtk_container_remove(GTK_CONTAINER(sub_menu),
								g_list_nth_data(glist,MENUFILE+history+1-3));
		g_list_free(glist);
	}
	if (count<=MENUFILE) {
		menu_item=gtk_menu_item_new();
		gtk_menu_insert(GTK_MENU(sub_menu),menu_item,MENUFILE-2);
		gtk_widget_show(menu_item);
	}
	label=g_strdup(file);
	menu_item=gtk_menu_item_new_with_label(label);
	gtk_signal_connect(GTK_OBJECT(menu_item),"activate",
						GTK_SIGNAL_FUNC(signal_activate_menu_history),label);
	gtk_signal_connect(GTK_OBJECT(menu_item),"destroy",
						GTK_SIGNAL_FUNC(signal_destroy_menu_history),label);
	gtk_object_set_user_data(GTK_OBJECT(menu_item),label);
	gtk_menu_insert(GTK_MENU(sub_menu),menu_item,MENUFILE-1);
	gtk_widget_show(menu_item);
}


/*	եä
	file,ä褦ȤեΥեѥ
	same,եѥ°
	 RET,ä褦ȤեΥ٥										*/
gchar *add_edit_file(gchar *file,gint *same)
{
	gchar *label,*name0,*name1;
	gint i;
	GList *glist;
	GtkWidget *child;
	VmaidWindow *vmaid;

	*same=-1;
	/* ե̾Ĵ٤ */
	glist=gtk_container_children(GTK_CONTAINER(notebook));
	/* Ʊ̾ƱѥĴ٤ */
	for (i=g_list_length(glist)-1;i>=0;i--) {
		child=g_list_nth_data(glist,i);
		vmaid=gtk_object_get_user_data(GTK_OBJECT(child));
		if (strcmp(file,vmaid->file)==0) {
			if (vmaid->same<0) {
				vmaid->same=0;
				label=g_strdup_printf("%s:%d",vmaid->file,vmaid->same);
				gtk_label_set_text(GTK_LABEL(vmaid->label),label);
				g_free(label);
			}
			if (*same<=vmaid->same)
				*same=vmaid->same+1;
		}
	}
	if (*same>=0) {
		/* Ʊ̾ƱѥȤ */
		label=g_strdup_printf("%s:%d",file,*same);
	} else {
		/* Ʊ̾ƱѥϤʤȤ */
		/* Ʊ̾ۥѥĴ٤ */
		name0=g_basename(file);
		for (i=g_list_length(glist)-1;i>=0;i--) {
			child=g_list_nth_data(glist,i);
			vmaid=gtk_object_get_user_data(GTK_OBJECT(child));
			name1=g_basename(vmaid->file);
			if (strcmp(name0,name1)==0) {
				if (vmaid->same<0)
					gtk_label_set_text(GTK_LABEL(vmaid->label),vmaid->file);
				break;
			}
		}
		label=g_strdup(i>=0?file:name0);
	}
	g_list_free(glist);
	return label;
}


/*	ե
	file,褦ȤեΥեѥ									*/
void delete_edit_file(gchar *file)
{
	gchar *name0,*name1;
	gint i,count=0;
	GList *glist;
	GtkWidget *child;
	VmaidWindow *vmaid;

	/* ե̾Ĵ٤ */
	glist=gtk_container_children(GTK_CONTAINER(notebook));
	/* Ʊ̾ۥѥĴ٤ */
	name0=g_basename(file);
	for (i=g_list_length(glist)-1;i>=0;i--) {
		vmaid=gtk_object_get_user_data(g_list_nth_data(glist,i));
		name1=g_basename(vmaid->file);
		if (strcmp(name0,name1)==0)
			count++;
	}
	if (count<=2) {
		/* Ʊ̾ۥѥΥե̾ɽѹ */
		for (i=g_list_length(glist)-1;i>=0;i--) {
			child=g_list_nth_data(glist,i);
			vmaid=gtk_object_get_user_data(GTK_OBJECT(child));
			name1=g_basename(vmaid->file);
			if (strcmp(name0,name1)==0)
				gtk_label_set_text(GTK_LABEL(vmaid->label),name1);
		}
	} else {
		/* Ʊ̾ƱѥĴ٤ */
		count=0;
		for (i=g_list_length(glist)-1;i>=0;i--) {
			vmaid=gtk_object_get_user_data(g_list_nth_data(glist,i));
			if (strcmp(file,vmaid->file)==0)
				count++;
		}
		if (count<=2)/* Ʊ̾ƱѥΥեեѥɽѹ */
			for (i=g_list_length(glist)-1;i>=0;i--) {
				child=g_list_nth_data(glist,i);
				vmaid=gtk_object_get_user_data(GTK_OBJECT(child));
				if (strcmp(file,vmaid->file)==0) {
					vmaid->same=-1;
					gtk_label_set_text(GTK_LABEL(vmaid->label),vmaid->file);
				}
			}
	}
}


/******************************************************************************
*                                                                             *
* եϴؿ                                                          *
*                                                                             *
******************************************************************************/
/*	AVIե򳫤
	 avi,AVIԽ¤
	file,ե̾															*/
static void open_avi_file(AviEdit *avi[],gchar *file)
{
	gint i;
	guint32 streams;
	AviEdit *avi_edit;

	avi[0]=avi[1]=NULL;
	streams=MAX(avi_main_streams(file),1);
	for (i=0;i<streams && (avi[0]==NULL || avi[1]==NULL);i++)
		if ((avi_edit=avi_open(file,i))!=NULL)
			switch (avi_type(avi_edit)) {
				case streamtypeVIDEO:
					if (avi[0]==NULL)
						avi[0]=avi_edit;
					else
						avi_release(avi_edit);
					break;
				case streamtypeAUDIO:
					if (avi[1]==NULL)
						avi[1]=avi_edit;
					else
						avi_release(avi_edit);
					break;
				default:
					avi_release(avi_edit);
			}
}


/*	ե򳫤(Ωå)
	open_file,Open
	 RET,ɥ														*/
VmaidWindow *open_edit_file(OpenFile *open_file)
{
	int fd;
	gboolean result;
	gchar *text=NULL,*format=NULL,*file,*dir,*name,*head,*foot,*scenario;
	gint i,j,value,max=0;
	off_t offset;
	pthread_t id;
	AviEdit *avi[2],*avi_edit[2],**avi_scenario;
	GdkPixmap *pixmap;
	GdkBitmap *mask;
	GtkWidget *xbox,*hbox,*vbox,*sub_menu,*button,*frame;
	VmaidWindow *vmaid;
	static gint fcount=0;	/* եο */
	static gchar *xpm[]={
"8 7 2 1",
" 	c None",
".	c #000000",
"..    ..",
" ..  .. ",
"  ....  ",
"   ..   ",
"  ....  ",
" ..  .. ",
"..    .."};

	id=pthread_self();
	thread_insert(id,1,open_file!=NULL?open_file->file:NULL);

	vmaid=g_malloc(sizeof(VmaidWindow));
	vmaid->edit=FALSE;
	vmaid->same=-1;
	vmaid->undo=vmaid->redo=NULL;
	vmaid->rate=default_rate;
	vmaid->scale=1;
	vmaid->cursor.stream=0;
	vmaid->cursor.frame=0;
	vmaid->select.stream=-1;
	vmaid->select.frame=-1;
	vmaid->top=0;
	vmaid->avi[0]=NULL;
	vmaid->avi[1]=NULL;
	vmaid->timer_id=0;
	if (open_file==NULL) {
		/*  */
		vmaid->file=g_strdup_printf("new%04d",fcount++%1000);
	} else {
		vmaid->file=get_full_path(open_file->file);
		g_free(open_file->file);
		open_avi_file(vmaid->avi,vmaid->file);
		if ((vmaid->avi[0]!=NULL || vmaid->avi[1]!=NULL) && open_file->merge) {
			/* Ϣ */
			name=g_basename(vmaid->file);
			for (i=strlen(name)-1;i>=0;i--)
				if ('0'<=name[i] && name[i]<='9')
					break;
			if (i>=0) {
				dir=g_dirname(vmaid->file);
				head=g_strdup(name);
				foot=name+i+1;
				for (j=i-1;j>=0;j--)
					if (head[j]<'0' || '9'<head[j])
						break;
				strval(&value,head+j+1,10,FALSE);
				head[j+1]='\0';
				format=g_strdup_printf("%s/%s%%0%dd%s",dir,head,i-j,foot);
				g_free(dir);
				g_free(head);
				max=1;
				while (j<i) {
					max*=10;
					j++;
				}
			}
		}
		if (format!=NULL) {
			result=TRUE;
			for (i=value-1;i>=0;i--) {
				file=g_strdup_printf(format,i);
				open_avi_file(avi,file);
				g_free(file);
				if (avi[0]==NULL && avi[1]==NULL)
					break;
				for (j=0;j<2;j++)
					if (vmaid->avi[j]!=NULL) {
						avi_edit[j]=avi_clone(vmaid->avi[j]);
						if (!avi_paste(vmaid->avi[j],0,avi[j]))
							result=FALSE;
					} else {
						avi_edit[j]=NULL;
						vmaid->avi[j]=avi[j];
					}
				if (result) {
					for (j=0;j<2;j++)
						if (avi_edit[j]!=NULL)
							avi_release(avi_edit[j]);
				} else {
					for (j=0;j<2;j++) {
						if (vmaid->avi[j]!=NULL)
							avi_release(vmaid->avi[j]);
						vmaid->avi[j]=avi_edit[j];
					}
				}
			}
			result=TRUE;
			for (i=value+1;i<max;i++) {
				file=g_strdup_printf(format,i);
				open_avi_file(avi,file);
				g_free(file);
				if (avi[0]==NULL && avi[1]==NULL)
					break;
				for (j=0;j<2;j++)
					if (vmaid->avi[j]!=NULL) {
						avi_edit[j]=avi_clone(vmaid->avi[j]);
						if (!avi_paste(vmaid->avi[j],
											avi_length(vmaid->avi[j]),avi[j]))
							result=FALSE;
					} else {
						avi_edit[j]=NULL;
						vmaid->avi[j]=avi[j];
					}
				if (result) {
					for (j=0;j<2;j++)
						if (avi_edit[j]!=NULL)
							avi_release(avi_edit[j]);
				} else {
					for (j=0;j<2;j++) {
						if (vmaid->avi[j]!=NULL)
							avi_release(vmaid->avi[j]);
						vmaid->avi[j]=avi_edit[j];
					}
				}
			}
		}
		if (vmaid->avi[0]==NULL && vmaid->avi[1]==NULL
											&& avi_file_type(vmaid->file)==3) {
			/* ե򳫤 */
			if ((fd=open(vmaid->file,O_RDONLY))==-1) {
				g_free(open_file);
				g_free(vmaid->file);
				g_free(vmaid);
				return NULL;
			}
			/* ɤ߹ */
			if (flock(fd,LOCK_SH)==-1 || (offset=lseek(fd,0,SEEK_END))==-1
									|| lseek(fd,0,SEEK_SET)==-1
									|| (scenario=g_malloc(offset+1))==NULL) {
				close(fd);
				g_free(open_file);
				g_free(vmaid->file);
				g_free(vmaid);
				return 0;
			}
			scenario[offset]='\0';
			if (read(fd,scenario,offset)!=offset) {
				close(fd);
				g_free(scenario);
				g_free(open_file);
				g_free(vmaid->file);
				g_free(vmaid);
				return 0;
			}
			if (close(fd)!=0) {
				g_free(scenario);
				g_free(open_file);
				g_free(vmaid->file);
				g_free(vmaid);
				return 0;
			}
			if ((avi_scenario=avi_from_scenario(scenario))!=NULL)
				for (i=0;avi_scenario[i]!=NULL;i++)
					switch (avi_type(avi_scenario[i])) {
						case streamtypeVIDEO:
							if (vmaid->avi[0]==NULL)
								vmaid->avi[0]=avi_scenario[i];
							else
								avi_release(avi_scenario[i]);
							break;
						case streamtypeAUDIO:
							if (vmaid->avi[1]==NULL)
								vmaid->avi[1]=avi_scenario[i];
							else
								avi_release(avi_scenario[i]);
							break;
						default:
							avi_release(avi_scenario[i]);
					}
		}
	}

	if (!thread_idling(id,100)) {
		g_free(open_file);
		g_free(vmaid->file);
		for (i=0;i<2;i++)
			if (vmaid->avi[i]!=NULL)
				avi_release(vmaid->avi[i]);
		g_free(vmaid);
		return NULL;
	}

	if (vmaid->avi[0]!=NULL) {
		set_scale(default_view,&vmaid->width,&vmaid->height,
				avi_get_width(vmaid->avi[0]),avi_get_height(vmaid->avi[0]));
		vmaid->rate=avi_rate(vmaid->avi[0]);
		vmaid->scale=avi_scale(vmaid->avi[0]);
	} else {
		set_scale(default_view,&vmaid->width,&vmaid->height,-1,-1);
	}
	if (vmaid->avi[0]==NULL && vmaid->avi[1]!=NULL)
		vmaid->cursor.stream=1;

	gdk_threads_enter();

	/* ե̾Ĵ٤ */
	text=add_edit_file(vmaid->file,&vmaid->same);

	/* ɽꥢ */
	vmaid->drawing=gtk_drawing_area_new();
	gtk_signal_connect(GTK_OBJECT(vmaid->drawing),"focus-in-event",
								GTK_SIGNAL_FUNC(signal_focus_in),vmaid);
	gtk_signal_connect(GTK_OBJECT(vmaid->drawing),"focus-out-event",
								GTK_SIGNAL_FUNC(signal_focus_out),vmaid);
	gtk_signal_connect(GTK_OBJECT(vmaid->drawing),"realize",
								GTK_SIGNAL_FUNC(signal_realize),NULL);
	gtk_signal_connect(GTK_OBJECT(vmaid->drawing),"configure-event",
								GTK_SIGNAL_FUNC(signal_config),vmaid);
	gtk_signal_connect(GTK_OBJECT(vmaid->drawing),"expose-event",
								GTK_SIGNAL_FUNC(signal_expose),vmaid);
	gtk_signal_connect(GTK_OBJECT(vmaid->drawing),"button-press-event",
								GTK_SIGNAL_FUNC(signal_button_press),vmaid);
	gtk_signal_connect(GTK_OBJECT(vmaid->drawing),"motion-notify-event",
								GTK_SIGNAL_FUNC(signal_motion_notify),vmaid);
	gtk_signal_connect(GTK_OBJECT(vmaid->drawing),"button-release-event",
								GTK_SIGNAL_FUNC(signal_button_release),vmaid);
	gtk_signal_connect_after(GTK_OBJECT(vmaid->drawing),"key-press-event",
								GTK_SIGNAL_FUNC(signal_key_press),vmaid);
	gtk_signal_connect(GTK_OBJECT(vmaid->drawing),"destroy",
								GTK_SIGNAL_FUNC(signal_destroy_draw),vmaid);
	gtk_widget_add_events(vmaid->drawing,GDK_FOCUS_CHANGE
						| GDK_BUTTON_PRESS_MASK | GDK_POINTER_MOTION_MASK
						| GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_RELEASE);
	gtk_widget_set_usize(vmaid->drawing,vmaid->width*3+4,system_fontheight*2
		+((vmaid->avi[0]!=NULL?1:0)+(vmaid->avi[1]!=NULL?1:0))*vmaid->height);
	GTK_WIDGET_SET_FLAGS(vmaid->drawing,GTK_CAN_FOCUS);
	/* С */
	vmaid->hscroll=gtk_hscrollbar_new(
							GTK_ADJUSTMENT(gtk_adjustment_new(0,0,0,1,1,1)));
	/* ܥå */
	xbox=gtk_hbox_new(FALSE,0);
	vbox=gtk_vbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox),vmaid->drawing,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox),vmaid->hscroll,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(xbox),vbox,FALSE,FALSE,0);
	gtk_object_set_user_data(GTK_OBJECT(xbox),vmaid);
	/* ˥塼 */
	sub_menu=gtk_item_factory_get_widget(item_factory_menu,
													_("<main>/ɥ(W)"));
	vmaid->menu_item=gtk_menu_item_new_with_label(vmaid->file);
	gtk_signal_connect(GTK_OBJECT(vmaid->menu_item),"activate",
						GTK_SIGNAL_FUNC(signal_activate_menu_window),xbox);
	gtk_menu_append(GTK_MENU(sub_menu),vmaid->menu_item);
	gtk_widget_show(vmaid->menu_item);
	/* ܥ */
	button=gtk_button_new();
	frame=gtk_frame_new(NULL);
	gtk_button_set_relief(GTK_BUTTON(button),GTK_RELIEF_NONE);
	pixmap=gdk_pixmap_create_from_xpm_d(window->window,&mask,NULL,xpm);
	gtk_container_add(GTK_CONTAINER(frame),gtk_pixmap_new(pixmap,mask));
	gtk_container_add(GTK_CONTAINER(button),frame);
	gtk_signal_connect(GTK_OBJECT(button),"clicked",signal_clicked,xbox);
	/* ٥ */
	vmaid->label=gtk_label_new(text);
	g_free(text);
	/* ɽ */
	hbox=gtk_hbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(hbox),vmaid->label,TRUE,TRUE,0);
	gtk_box_pack_end(GTK_BOX(hbox),button,FALSE,FALSE,0);
	gtk_notebook_append_page(GTK_NOTEBOOK(notebook),xbox,hbox);
	gtk_widget_show_all(hbox);
	gtk_widget_show_all(xbox);
	gtk_notebook_set_page(GTK_NOTEBOOK(notebook),
						gtk_notebook_page_num(GTK_NOTEBOOK(notebook),xbox));
	gtk_widget_grab_focus(vmaid->drawing);

	/* ǤϤʤե뤬¸ߤˤ˲ä */
	if (open_file!=NULL && history>0 && isfile(vmaid->file))
		set_history(vmaid->file);

	gdk_threads_leave();

	g_free(open_file);
	thread_delete(id);
	return vmaid;
}


/******************************************************************************
*                                                                             *
* եϴؿ                                                          *
*                                                                             *
******************************************************************************/
static gboolean save_edit_file_callback(gint percent,gpointer user_data)
{
	return thread_idling(pthread_self(),percent);
}


/*	AVIե¸
	save_file,Save
	      RET,TRUE:ｪλ,FALSE:顼									*/
gboolean save_edit_file(SaveFile *save_file)
{
	int fd;
	gboolean result=TRUE;
	gchar *scenario;
	gint i,j=0,length;
	pthread_t id;
	AviEdit *avi[3];

	id=pthread_self();
	thread_insert(id,2,save_file->file);

	switch (save_file->mode) {
		case 2:
			avi[j++]=save_file->avi[1];
		case 1:
			break;
		default:
			for (i=0;i<2;i++)
				if (save_file->avi[i]!=NULL)
					avi[j++]=save_file->avi[i];
	}

	if (save_file->mode==1) {
		result=avi_save_bitmap(save_file->avi[0],save_file->file,
				save_file->start,save_file->end,save_edit_file_callback,NULL);
	} else {
		avi[j++]=NULL;
		if (save_file->mode!=3) {
			result=avi_save(avi,save_file->file,save_edit_file_callback,NULL);
		} else if ((scenario=avi_to_scenario(avi,FALSE))!=NULL) {
			if ((fd=open(save_file->file,O_CREAT|O_EXCL|O_WRONLY,
					S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH|S_IWOTH))!=-1) {
				length=strlen(scenario);
				if (flock(fd,LOCK_EX)==-1 || write(fd,scenario,length)!=length)
					result=FALSE;
				g_free(scenario);
				if (close(fd)!=0)
					result=FALSE;
			} else {
				result=FALSE;
			}
		}
	}

	g_free(save_file->file);
	for (i=0;i<2;i++)
		if (save_file->avi[i]!=NULL)
			avi_release(save_file->avi[i]);
	g_free(save_file);

	if (!result)
		while (thread_idling(id,-1));

	thread_delete(id);
	return result;
}
